
import no.rwr.x.*;
import no.rwr.xutil.*;
import java.awt.Rectangle;

public class TestWindow {
    public static void main(String[] args) {

	Display display;
	display = new Display();

	no.rwr.x.Window root = display.getDefaultRootWindow();
	
	/* This is an old approch to addressing color allocation. It
           will probably be phased out. */
	ColorContext cc = new ColorContext(display.getDefaultScreen());
	long blue = cc.getPixelValue(0x0000, 0x0000,0xffff);
	long gray = cc.getPixelValue(0xa8a8, 0xa8a8, 0xa8a8);
	long pink = cc.getPixelValue(0xffff, 0xa8a8, 0xa8a8);
	Visual visual = cc.getVisual();

	WindowAttributes frameAttributes = new WindowAttributes();
	frameAttributes.setVisual(visual);
	frameAttributes.setBackground(blue);


	// Using a toplevel frame
        Frame frame = new no.rwr.xutil.Frame();
	frame.setScreen(display.getDefaultScreen());
	frame.setAttributes(frameAttributes);
	frame.setTitle("Test window");
	frame.setSize(300, 350);


	// Using the simple X Window wrapper
	Rectangle bounds = new Rectangle(50, 50, 200, 100);
	WindowAttributes winAttributes = new WindowAttributes();
	winAttributes.setBackground(gray);
	no.rwr.x.Window parent = frame.getWindow();
	no.rwr.x.Window myInnerWindow =
	    new no.rwr.x.Window(frame.getWindow(), bounds,
				winAttributes);
	myInnerWindow.map();


	// Using a custom canvas component
	WindowAttributes canvasAttributes = new WindowAttributes();
	canvasAttributes.setBackground(pink);

	// this fails due to a compiler bug.
	//canvasAttributes.setEventMask(WindowAttributes.MASK_EXPOSURE);
	//using...
	canvasAttributes.setEventMask(1L<<15);
	// instead.

	Canvas drawCanvas = new TestCanvas();
	drawCanvas.setPosition(50, 200);
	drawCanvas.setSize(200, 100);
	drawCanvas.setAttributes(canvasAttributes);
	drawCanvas.setParent(frame);

	
	
	frame.setVisible(true);

	// Running event loop
	Dispatcher dispatcher = new Dispatcher(display);
	dispatcher.run();
    }

}

// Custom canvas component
class TestCanvas extends no.rwr.xutil.Canvas {

    ColorContext cc = null;
    long white, black, gray, shadow;
    GC gc;
    no.rwr.x.Font font;

    
    protected void exposed(XExposeEvent xee) {

	// ALERT: REALLY BAD TEST CODE!

	if (cc == null) { 	    // Initialize only once
	    cc = new ColorContext(getWindow().getDisplay());
	    
	    white  = cc.getPixelValue(0xffff, 0xffff, 0xffff);
	    black  = cc.getPixelValue(0x0000, 0x0000, 0x0000);
	    gray   = cc.getPixelValue(0xcccc, 0xcccc, 0xcccc);
	    shadow = cc.getPixelValue(0x8000, 0x8000, 0x8000);
	    gc = new GC(getWindow());
	    String fontName =
		"-adobe-helvetica-medium-r-normal-*-*-240-*-*-p-*-iso8859-1";
	    font = new no.rwr.x.Font(getWindow().getDisplay(), fontName);
	}

	
	gc.setForeground(white);

	/* Draw a rectangle around the exposed area, making it
	   possible "see" the exposures. */
	Rectangle r = xee.getBounds();
	
	gc.drawRectangle(r.x, r.y, r.width-1, r.height-1);


	// Draw some other stuff

	gc.drawLine(10, 10, 89, 10);
	gc.drawLine(10, 29, 10, 10);
	
	gc.setForeground(shadow);
	gc.drawLine(89, 11, 89, 29);
	gc.drawLine(89, 29, 11, 29);	    
	
	gc.setForeground(black);
	gc.drawLine(90, 10, 90, 30);
	gc.drawLine(90, 30, 10, 30);	    
	
	gc.setFont(font);
	
	gc.drawString("Hello", 30, 70);


	
	
    }

}
