package java.awt;
import java.awt.image.ImageProducer;
import java.awt.image.ImageObserver;

public abstract class Image {
    public static final Object UndefinedProperty;

    public static final int SCALE_DEFAULT = 1;
    public static final int SCALE_FAST = 2;
    public static final int SCALE_SMOOTH = 4;
    public static final int SCALE_REPLICATE = 8;
    public static final int SCALE_AREA_AVERAGING = 16;

    public abstract int getWidth(ImageObserver observer);

    public abstract int getHeight(ImageObserver observer);

    public abstract ImageProducer getSource();

    public abstract Graphics getGraphics();

    public abstract Object getProperty(String name, ImageObserver observer);

    public Image getScaledInstance(int width, int height, int hints) {
	throw new UnsupportedOperationException("not yet implemented");
    }

    public abstract void flush();
}


