package java.awt;
import java.awt.peer.*;
import java.awt.image.*;
import java.awt.event.*;
//import java.awt.dnd.peer.*;
import java.beans.*;
//import java.util.Map;
//import java.util.HashMap;
import java.net.*;


/* Stub class...  Most things are unimplemented due to requiring other
   unimplemented classes or due to the horrible state of the Java API
   docs. The docs fail to even give a vague idea of what half of the
   methods in this class should do. Open, crossplatform API, my
   foot. */
public abstract class Toolkit extends java.lang.Object { 
    //protected final Map desktopProperties;

    protected final PropertyChangeSupport desktopPropsSupport;

    protected abstract ButtonPeer     createButton(Button         frontend);
    /*
    protected abstract TextFieldPeer  createTextField(TextField   frontend);
    protected abstract LabelPeer      createLabel(Label           frontend);
    protected abstract ListPeer       createList(List             frontend);
    protected abstract CheckboxPeer   createCheckbox(Checkbox     frontend);
    protected abstract ScrollbarPeer  createScrollbar(Scrollbar   frontend);
    protected abstract ScrollPanePeer createScrollPane(ScrollPane frontend);
    protected abstract TextAreaPeer   createTextArea(TextArea     frontend);
    protected abstract ChoicePeer     createChoice(Choice         frontend);
    */

    protected abstract FramePeer      createFrame(Frame           frontend);
    protected abstract CanvasPeer     createCanvas(Canvas         frontend);
    protected abstract PanelPeer      createPanel(Panel           frontend);

    /*
    protected abstract WindowPeer     createWindow(Window         frontend);
    protected abstract DialogPeer     createDialog(Dialog         frontend);
    protected abstract MenuBarPeer    createMenuBar(MenuBar       frontend);
    protected abstract MenuPeer       createMenu(Menu             frontend);
    protected abstract PopupMenuPeer  createPopupMenu(PopupMenu   frontend);
    protected abstract MenuItemPeer   createMenuItem(MenuItem     frontend);
    protected abstract FileDialogPeer createFileDialog(FileDialog frontend);
    protected abstract CheckboxMenuItemPeer
	createCheckboxMenuItem(CheckboxMenuItem                   frontend);
    */

    protected LightweightPeer createComponent(Component frontend) {
	return no.rwr.awt.GLightweightPeer.INSTANCE;
    }

    /*
    protected abstract FontPeer getFontPeer(String name, int style);
    */

    protected void loadSystemColors(int[] systemColors) {}

    public abstract Dimension getScreenSize();
    public abstract int getScreenResolution();
    public abstract ColorModel getColorModel();
    public abstract String[] getFontList();

    public abstract FontMetrics getFontMetrics(Font font);

    public abstract void sync();



    private static Toolkit defaultToolkit;
    
    public static Toolkit getDefaultToolkit() {
	if (defaultToolkit != null) return defaultToolkit;

	
	String toolkitName = System.getProperty("awt.toolkit");

	if (toolkitName != null) {
	    Toolkit tk = attemptToolkitCreation(toolkitName);
	    if (tk != null) return tk;
	} else {

	    /* This implementation violates the API specification,
	       since it doesn't seem right to default to using
	       "sun.awt.motif.MToolkit" in a free implementation of
	       the Java class libraries. */

	    final String[] defaultToolkits = {
		// "sun.awt.motif.MToolkit",
		"java.awt.peer.GtkToolkit",
		"no.rwr.awt.x.XToolkit"
	    };
	    
	    for (int i=0; i<defaultToolkits.length; i++) {
		defaultToolkit = attemptToolkitCreation(defaultToolkits[i]);
		if (defaultToolkit != null) return defaultToolkit;
	    }
	}
	throw new AWTError("class for default AWT toolkit missing");
    }
    
    private static Toolkit attemptToolkitCreation(String name) {
	ClassLoader cl = ClassLoader.getSystemClassLoader();
	try {
	    return (Toolkit) cl.loadClass(name).newInstance();
	} catch (ClassNotFoundException e) {
	} catch (InstantiationException e) {
	} catch (IllegalAccessException e) {
	}	

	return null;
    }



    public abstract Image getImage(String filename);
    public abstract Image getImage(URL url);
    public abstract Image createImage(String filename);
    public abstract Image createImage(URL url);
    public abstract boolean prepareImage(Image image,
					 int width,
					 int height,
					 ImageObserver observer);

    public abstract int checkImage(Image image,
				   int width,
				   int height,
				   ImageObserver observer);

    public abstract Image createImage(ImageProducer producer);

    public Image createImage(byte[] imagedata) {
	return createImage(imagedata, 0, imagedata.length);
    }

    public abstract Image createImage(byte[] imagedata,
				      int imageoffset,
				      int imagelength);
	
    /*
    public abstract PrintJob getPrintJob(Frame frame,
					 String jobtitle,
					 Properties props);
    
    public PrintJob getPrintJob(Frame frame,
				String jobtitle,
				JobAttributes jobAttributes,
				PageAttributes pageAttributes) {
	getPrintJob(frame, jobtitle, jobAttributes, pageAttributes);
    }
    */

    public abstract void beep();

    /*
    public abstract Clipboard getSystemClipboard();
    */

    public int getMenuShortcutKeyMask() {
	return Event.CTRL_MASK;
    }
    
    public boolean getLockingKeyState(int keyCode) {
	throw new UnsupportedOperationException();
    }
    
    public void setLockingKeyState(int keyCode, boolean on) {
	throw new UnsupportedOperationException();
    }
    
    protected static Container getNativeContainer(Component c) {
	while (c != null) {
	    boolean lightweight = c.isLightweight();

	    if ((!lightweight) && c instanceof Container)
		return (Container) c;
	    
	    c = c.getParent();
	}
	return null;
    }

    /*
    public Cursor createCustomCursor(Image cursor,
				     Point hotSpot,
				     String name)
	throws IndexOutOfBoundsException {
	return new Cursor(Cursor.CUSTOM_CURSOR);
    }
    */

    public Dimension getBestCursorSize(int preferredWidth,
				       int preferredHeight) {
	return new Dimension();
    }
    

    public int getMaximumCursorColors() {
	return 0;
    }

    public static String getProperty(String key,
				     String defaultValue) {
	Object prop = null;
	/* FIXME: try to look up property from some kind of property
	   set.  The Javadocs doesn't explain what this method
	   actually should return. I'm guessing it is not a desktop
	   property, since they have their own methods. */
	
	return (prop == null) ? defaultValue : (String) prop;
    }

    public final EventQueue getSystemEventQueue() {
	return getSystemEventQueueImpl();
    }
    
    // why two methods?
    protected abstract EventQueue getSystemEventQueueImpl();


    /*
    public abstract DragSourceContextPeer
	createDragSourceContextPeer(DragGestureEvent dge)
	throws InvalidDnDOperationException;

    public DragGestureRecognizer
	createDragGestureRecognizer(Class abstractRecognizerClass,
				    DragSource ds, Component c,
				    int srcActions, DragGestureListener dgl) {
	throw new UnsupportedOperationException("not implemented");
    }
    */

    public final Object getDesktopProperty(String propertyName) {

	// FIXME:
	return null;
	/*
	if (desktopProperties == null) {
	    desktopProperties = new HashMap(); // necessary?
	    initializeDesktopProperties();
	}

	Object prop = desktopProperties.get(propertyName);
	if (prop != null) return prop;

	prop = lazilyLoadDesktopProperty(propertyName);
	if (prop == null) return null;
	
	setDesktopProperty(propertyName, prop);
	return prop;
	*/
    }

    /*
    protected final void setDesktopProperty(String name,
					    Object newValue) {
	desktopProperties.set(name, newValue);
    }
    */

    protected Object lazilyLoadDesktopProperty(String name) {
	return null; // I guess... Java API docs are a joke!
    }

    protected void initializeDesktopProperties() {}
    
    public void addPropertyChangeListener(String name,
					  PropertyChangeListener pcl) {}
    

    public void removePropertyChangeListener(String name,
					     PropertyChangeListener pcl) {}
    

    // Hook windowing event-loop in here.
    public void addAWTEventListener(AWTEventListener listener,
				    long eventMask) {}
    
    public void removeAWTEventListener(AWTEventListener listener) {}

    /*
    public abstract Map
	mapInputMethodHighlight(InputMethodHighlight highlight);
    */
}
