package java.awt.peer;
import java.awt.*;
import java.awt.image.*;

/**
   Sun has not properly published its peer API since JDK 1.0.2. Sun
   states: "Note: API in the java.awt.peer package is always subject
   to change because the peer classes aren't intended to be called
   directly by developers."

   I've therefore taken the liberty of defining the API based on the
   needs of the toolkits we're implementing.  */

	 


public interface ComponentPeer {
    
    Toolkit getToolkit ();
    Graphics getGraphics();
    Dimension getMinimumSize();
    Dimension getPreferredSize();
    GraphicsConfiguration getGraphicsConfiguration();

    void setBounds (int x, int y, int w, int h);
    void paint(java.awt.Graphics graphics);
    void setVisible(boolean visible);
    void setForeground(Color color);
    void setBackground(Color color);
    void setFont(Font font);

    void processEvent(AWTEvent awtevent);

    void repaint(int x, int y, int w, int h);
    void setEventMask(long eventMask);
}
