package no.rwr.data;
import java.awt.image.DataBuffer;

public abstract class TypeConverter {

    public static TypeConverter getConverter(int dataType) {
	switch (dataType) {
	case DataBuffer.TYPE_BYTE:
	    return ByteConverter.INSTANCE;
	default:
	    throw new UnsupportedOperationException();
	}
    }

    public abstract byte[]    toByteArray(Object inData);
    public abstract short[] toUShortArray(Object inData);
    public abstract int[]      toIntArray(Object inData);
    public abstract float[]  toFloatArray(Object inData);

    public abstract int getInt(Object inData, int index);
}
