#include <X11/Xlib.h>
#include <gcj/cni.h>
#include <gnu/gcj/RawData.h>
#include <vector>
#include <java/awt/Rectangle.h>

#include "no/rwr/x/Clip.h"

typedef java::awt::Rectangle AWTRect;
typedef JArray<AWTRect*> AWTRectArray;
typedef vector<XRectangle> XRectVector;


void no::rwr::x::Clip::init(AWTRectArray* rectangles) {

    // Prepare rectangles:

    int numRect = JvGetArrayLength(rectangles);
    XRectVector* xrectvector = new XRectVector(numRect);

    for (int i=0; i<numRect; i++) {
	AWTRect* awtrect = elements(rectangles)[i];
	XRectangle& xrect = (*xrectvector)[i];

	xrect.x      = awtrect->x;
	xrect.y      = awtrect->y;
	xrect.width  = awtrect->width;
	xrect.height = awtrect->height;
    }

    xrects = reinterpret_cast<gnu::gcj::RawData*>(xrectvector);
}

void no::rwr::x::Clip::finalize() {
    delete xrects;
    xrects = 0;
}
