#include <X11/Xlib.h>


#include <gcj/cni.h>
#include <gnu/gcj/RawData.h>

#include "no/rwr/x/XException.h"
#include "no/rwr/x/Display.h"
#include "no/rwr/x/Drawable.h"
#include "no/rwr/x/XImage.h"

#include "java/awt/Rectangle.h"

jboolean
    no::rwr::x::Drawable::_copyIntoXImage(XImage* image,
					  jint x, jint y,
					  jint width, jint height,
					  jint destX, jint destY) {
    
    ::Display* dpy = (::Display*) (getDisplay()->display);
    ::XImage* ximage = (::XImage*) image->structure;
    int format = image->getFormat();
    int xid = getXID();

    ::XImage* result = XGetSubImage(dpy, xid,
				    x, y, width, height,
				    ~0, // plane mask
				    format,
				    ximage,
				    destX, destY);
    if (result == 0) return false;
    
    if (result != ximage) JvThrow(new XException(MSG_XGETSUBIMAGE_FAILED));

    return true;
}

java::awt::Rectangle*
    no::rwr::x::Drawable::getBounds(java::awt::Rectangle* rv) {
    ::Display* dpy = (::Display*) (getDisplay()->display);

    ::Window root;
    int x, y;
    unsigned int w, h, bw, depth;

    int xid = getXID();

    Status status = XGetGeometry(dpy, getXID(), &root,
				 &x, &y, &w, &h,
				 &bw, &depth);

    switch (status) {
    case BadDrawable:
	 JvThrow(new XException(display, status));
    default:
	; // All OK, NOP.
    }
    if (rv == 0) {
	rv = new java::awt::Rectangle(x, y, w, h);
    } else {
	rv->x = x;
	rv->y = y;
	rv->width = w;
	rv->height = h;
    }
    return rv;
}
