package no.rwr.xutil;

import no.rwr.x.*;


public class TopLevelWindow extends Canvas {

    WMSizeHints normalSizeHints;

    public TopLevelWindow() {
	visible = false;
    }
    public void setScreen(Screen screen) {
	setParent(screen.getRootWindow());
    }
    public void setNormalSizeHints(WMSizeHints hints) {
	normalSizeHints = hints;
	checkNormalSizeHints();
	if (normalSizeHints == null) {
	    // save private copy
	    normalSizeHints = (WMSizeHints) normalSizeHints.clone();
	}
    }
    private void checkNormalSizeHints() {
	if (!(valid && mapped)) return;
	if (normalSizeHints == null) return;
	
	normalSizeHints.applyNormalHints(getWindow());
	normalSizeHints = null;
    }

    public void setGroupLeader(TopLevelWindow leader) {
	// FIXME TODO
    }


    protected void unmap() {
	super.unmap();


	// Withdraw the toplevel window according to ICCCM rules:
	no.rwr.x.Window window = getWindow();
	no.rwr.x.Window parent = getParent(); // root (hopefully)

	if (parent != window.getDisplay().getDefaultRootWindow()) {
	    System.err.println("WARNING: logical parent of toplevel window" +
			       "is not the default root window");
	}

	XUnmapEvent syntheticEvent = new XUnmapEvent(window.getDisplay(),
						     parent,
						     window,
						     false);

	XAnyEvent anyEvent = syntheticEvent.getXAnyEvent();

	
	long eventFlags = (1L<<19) | (1L<<20);
	/* The line above should be...
	   long eventFlags =
	       XAnyEvent.MASK_SUBSTRUCTURE_REDIRECT |
	       XAnyEvent.MASK_SUBSTRUCTURE_NOTIFY;
           But this makes the compiler SEGV
	*/

	anyEvent.send(parent, false, eventFlags);
    }

    public void whenMapped() {
	checkNormalSizeHints();

	// Call super. Doing this, and doing this last, is very important.
	super.whenMapped();
    }

    public void processClientMessage(ClientMessageEvent message) {
	Display display = getWindow().getDisplay();
	int xa_WM_PROTOCOLS = display.getAtom("WM_PROTOCOLS");

	if (message.getMessageTypeAtom() == xa_WM_PROTOCOLS) {
	    int protocolAtom = message.getInt(0);
	    String protocol = display.getAtomName(protocolAtom);
	    System.err.println("warning: Window manager is bothering me "+
			       "with: " + protocol);
	}

	System.err.println("warning: Unknown client message: " + message);
	super.processClientMessage(message);
    }

}
