package java.awt;
import java.awt.peer.ComponentPeer;
import java.awt.peer.ButtonPeer;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;
import java.util.EventListener;

public class Button extends Component {

    String label;
    String command;
    
    // FIXME: Implement AWTMulticaster instead
    Vector actionListeners = new Vector();


    public Button() {}

    public Button(String label) {
	setLabel(label);
    }

    public void addNotify() {
	if (getPeer() == null) {
	    // See Frame.java for comment on synchronization
	    synchronized (this) {
		ComponentPeer peer = getToolkit().createButton(this);
		setPeer(peer);  
	    }
	}
	super.addNotify();
    }

    public String getLabel() {
	return label;
    }

    public void setLabel(String label) {
	this.label = label;
	ButtonPeer peer = (ButtonPeer) getPeer();
	if (peer != null) peer.setLabel(label);
    }

    public void setActionCommand(String command) {
	this.command = command;
    }

    public String getActionCommand() {
	return command;
    }

    public void addActionListener(ActionListener listener) {
	actionListeners.addElement(listener);
	// FIXME: notify peer, in case the event mask may need to be changed
    }

    public void removeActionListener(ActionListener listener) {
	mouseListeners.removeElement(listener);
	// FIXME: notify peer, in case the event mask may need to be changed

    }

    public EventListener[] getListeners(Class listenerClass) {
	
	if (listenerClass == ActionListener.class) {
	    ActionListener[] arr = new ActionListener[actionListeners.size()];
	    actionListeners.copyInto(arr);
	    return arr;
	}

	return super.getListeners(listenerClass);
    }
    

    protected void processEvent(AWTEvent event) {
	if (event instanceof ActionEvent) {
	    processActionEvent((ActionEvent) event);
	    return;
	}

	super.processEvent(event);
    }

    protected void processActionEvent(ActionEvent event) {
	ActionListener[] listeners = (ActionListener[])
	    getListeners(ActionListener.class);
	
	for (int i=0; i<listeners.length; i++) {
	    listeners[i].actionPerformed(event);
	}
    }

    //protected String paramString();

    //public AccessibleContext getAccessibleContext();
}
